#ifndef __ABAC_PL_GEN_H__
#define __ABAC_PL_GEN_H__

#include "abac_internal.h"
#include "abac_list.h"

#define PROLOG(BODY) {  \
    ABAC_IN_PROLOG++;   \
    { BODY }            \
    ABAC_IN_PROLOG--;   \
}

/* exported */
extern int ABAC_IN_PROLOG;

extern abac_list_t *generate_pl_clauses(abac_context_t *,abac_aspect_t*, abac_aspect_t*, char *,int);

/* used by abac_pl_pre only */
extern char *generate_pl_range_constraint(char*,char*,char*,char*);
extern char *generate_pl_range_time_constraint(char*,char*,char*);
extern char* generate_pl_constraint_clause(abac_context_t *,abac_aspect_t*, char*);
extern char *generate_pl_type_clause(abac_context_t *,char *, int);

extern void abac_pl_add_constraints(char *constraint);

#endif /* __ABAC_PL_GEN_H__ */
